
;CodeVisionAVR C Compiler V2.05.3 Standard
;(C) Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega16A
;Program type             : Application
;Clock frequency          : 8.000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 256 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;Global 'const' stored in FLASH     : No
;Enhanced function parameter passing: Yes
;Enhanced core instructions         : On
;Smart register allocation          : On
;Automatic register allocation      : On

	#pragma AVRPART ADMIN PART_NAME ATmega16A
	#pragma AVRPART MEMORY PROG_FLASH 16384
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1119
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x045F
	.EQU __DSTACK_SIZE=0x0100
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _Index=R4
	.DEF _hour=R7
	.DEF _min=R6
	.DEF _sec=R9
	.DEF _week_day=R8
	.DEF _day=R11
	.DEF _month=R10
	.DEF _year=R13
	.DEF __lcd_x=R12

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _usart_rx_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_keytbl:
	.DB  0x77,0x7B,0x7D,0xB7,0xBB,0xBD,0xD7,0xDB
	.DB  0xDD,0xEB,0xE7,0xED,0x7E,0xBE,0xDE,0xEE
_tbl10_G101:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G101:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

_0x3:
	.DB  0x1,0x2,0x3,0x4
_0x0:
	.DB  0x52,0x46,0x49,0x44,0x20,0x44,0x4F,0x4F
	.DB  0x52,0x20,0x53,0x45,0x43,0x0,0x49,0x44
	.DB  0x3D,0x0,0x20,0x53,0x65,0x6E,0x64,0x69
	.DB  0x6E,0x67,0x20,0x53,0x4D,0x53,0x20,0x0
	.DB  0x41,0x54,0x25,0x63,0x0,0x41,0x54,0x2B
	.DB  0x43,0x4D,0x47,0x46,0x3D,0x31,0x25,0x63
	.DB  0x0,0x41,0x54,0x2B,0x43,0x4D,0x47,0x53
	.DB  0x3D,0x25,0x63,0x30,0x39,0x31,0x39,0x34
	.DB  0x31,0x37,0x36,0x30,0x31,0x35,0x25,0x63
	.DB  0x25,0x63,0x0,0x6F,0x6B,0x20,0x49,0x44
	.DB  0x3D,0x0,0x25,0x64,0x3A,0x25,0x64,0x3A
	.DB  0x25,0x64,0x20,0x25,0x64,0x2F,0x25,0x64
	.DB  0x2F,0x25,0x64,0x2F,0x0,0x53,0x4D,0x53
	.DB  0x20,0x53,0x45,0x4E,0x54,0x20,0x20,0x20
	.DB  0x0,0x57,0x72,0x6F,0x6E,0x67,0x20,0x63
	.DB  0x61,0x72,0x64,0x0,0x45,0x72,0x72,0x6F
	.DB  0x72,0x20,0x49,0x44,0x3D,0x0,0x25,0x64
	.DB  0x0,0x50,0x61,0x73,0x73,0x3D,0x2A,0x0
	.DB  0x50,0x61,0x73,0x73,0x3D,0x2A,0x2A,0x0
	.DB  0x50,0x61,0x73,0x73,0x3D,0x2A,0x2A,0x2A
	.DB  0x0,0x50,0x61,0x73,0x73,0x3D,0x2A,0x2A
	.DB  0x2A,0x2A,0x0,0x53,0x65,0x74,0x20,0x73
	.DB  0x79,0x73,0x74,0x65,0x6D,0x20,0x54,0x69
	.DB  0x6D,0x65,0x0,0x3F,0x3F,0x3A,0x25,0x64
	.DB  0x3A,0x25,0x64,0x0,0x73,0x65,0x74,0x20
	.DB  0x73,0x79,0x73,0x74,0x65,0x6D,0x20,0x54
	.DB  0x69,0x6D,0x65,0x0,0x25,0x64,0x3A,0x3F
	.DB  0x3F,0x3A,0x25,0x64,0x0,0x53,0x65,0x74
	.DB  0x20,0x73,0x79,0x73,0x74,0x65,0x6D,0x20
	.DB  0x64,0x61,0x74,0x65,0x0,0x3F,0x3F,0x2F
	.DB  0x25,0x30,0x32,0x64,0x2F,0x25,0x30,0x32
	.DB  0x64,0x0,0x25,0x30,0x32,0x64,0x2F,0x3F
	.DB  0x3F,0x2F,0x25,0x64,0x0,0x25,0x30,0x32
	.DB  0x64,0x2F,0x25,0x30,0x32,0x64,0x2F,0x32
	.DB  0x30,0x3F,0x3F,0x0,0x45,0x6E,0x74,0x65
	.DB  0x72,0x20,0x50,0x61,0x73,0x73,0x77,0x6F
	.DB  0x72,0x64,0x3A,0x0,0x77,0x72,0x6F,0x6E
	.DB  0x67,0x20,0x50,0x61,0x73,0x73,0x0,0x45
	.DB  0x6E,0x74,0x65,0x72,0x20,0x31,0x20,0x6F
	.DB  0x72,0x20,0x32,0x20,0x3F,0x0,0x63,0x6C
	.DB  0x6F,0x73,0x65,0x20,0x63,0x61,0x72,0x64
	.DB  0x0,0x54,0x69,0x6D,0x65,0x3A,0x20,0x25
	.DB  0x32,0x64,0x3A,0x25,0x30,0x32,0x64,0x3A
	.DB  0x25,0x30,0x32,0x64,0x0,0x44,0x61,0x74
	.DB  0x65,0x3A,0x20,0x25,0x32,0x64,0x2F,0x25
	.DB  0x30,0x32,0x64,0x2F,0x25,0x64,0x0
_0x2000003:
	.DB  0x80,0xC0

__GLOBAL_INI_TBL:
	.DW  0x04
	.DW  _saved_pass
	.DW  _0x3*2

	.DW  0x02
	.DW  __base_y_G100
	.DW  _0x2000003*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;#include <mega16a.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <alcd.h>
;#include <delay.h>
;#include <stdio.h>
;#include <i2c.h>
;#include <ds1307.h>
;
;#define show_rfid_keypad_num 13 // this is num in keypad that u use as setting button
;#define Time_setting_keypad_num 14 //in keypad
;#define new_rfid_keypad_num 15 //in keypad
;#define show_time_keypad_num 16 // in key pad
;
;
;#define BUZZER PORTC.0
;#define RELAY PORTB.2
;#define LED1 PORTB.3
;#define LED2 PORTB.4
;
;#ifndef RXB8
;#define RXB8 1
;#endif
;
;#ifndef TXB8
;#define TXB8 0
;#endif
;
;#ifndef UPE
;#define UPE 2
;#endif
;
;#ifndef DOR
;#define DOR 3
;#endif
;
;#ifndef FE
;#define FE 4
;#endif
;
;#ifndef UDRE
;#define UDRE 5
;#endif
;
;#ifndef RXC
;#define RXC 7
;#endif
;
;#define FRAMING_ERROR (1<<FE)
;#define PARITY_ERROR (1<<UPE)
;#define DATA_OVERRUN (1<<DOR)
;#define DATA_REGISTER_EMPTY (1<<UDRE)
;#define RX_COMPLETE (1<<RXC)
;
;#define GSM_POWER_ON PORTD.3
;
;int Index;
;unsigned char Buff[22] ;
;unsigned char pass[5];// get pass from function
; char saved_pass[5]={1,2,3,4}; // saved  pass //eeprom

	.DSEG
;
; eeprom char saved_rfid_1[11]="0002208854";
; eeprom char saved_rfid_2[11]="0008989582";
;
;  unsigned char valid_check_rfid(char *id_buffer );
;  unsigned char get_keypad(void);//get keypad button number
;  unsigned char get_number(void);//get number in integer from get_keypad()
;  unsigned int get_pass(void);
;  unsigned char show_saved_rfid(void);
;  void time_setting(void);
;  unsigned char new_rfid_card(void);
;  void show_time_and_date(void);
;
; flash unsigned char keytbl[16]={0x77, 0x7B, 0x7D, 0xB7,
;  0xBB, 0xBD, 0xD7, 0xDB,
;   0xDD, 0xEB, 0xE7, 0xED,
;    0x7e,0xBE, 0xDE, 0xEE};
;
;    unsigned char hour,min,sec,week_day,day,month,year;
;
; void main(void){
; 0000 004F void main(void){

	.CSEG
_main:
; 0000 0050  char temp_buff[11],i=0;
; 0000 0051 
; 0000 0052  unsigned char val=0,fail_count=0;
; 0000 0053 
; 0000 0054 
; 0000 0055  DDRB=(1<<2)|(1<<3)|(1<<4); // led s and relay
	SBIW R28,11
;	temp_buff -> Y+0
;	i -> R17
;	val -> R16
;	fail_count -> R19
	LDI  R17,0
	LDI  R16,0
	LDI  R19,0
	LDI  R30,LOW(28)
	OUT  0x17,R30
; 0000 0056  DDRC=0X01; // BUZZER OUTPUT PIN
	LDI  R30,LOW(1)
	OUT  0x14,R30
; 0000 0057  DDRD=(1<<3);
	LDI  R30,LOW(8)
	OUT  0x11,R30
; 0000 0058  // USART initialization
; 0000 0059 // Communication Parameters: 8 Data, 1 Stop, No Parity
; 0000 005A // USART Receiver: On
; 0000 005B // USART Transmitter: On
; 0000 005C // USART Mode: Asynchronous
; 0000 005D // USART Baud Rate: 9600
; 0000 005E UCSRA=0x00;
	LDI  R30,LOW(0)
	OUT  0xB,R30
; 0000 005F UCSRB=0x98;
	LDI  R30,LOW(152)
	OUT  0xA,R30
; 0000 0060 UCSRC=0x86;
	LDI  R30,LOW(134)
	OUT  0x20,R30
; 0000 0061 UBRRH=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
; 0000 0062 UBRRL=0x33;
	LDI  R30,LOW(51)
	OUT  0x9,R30
; 0000 0063 
; 0000 0064  lcd_init(16);
	LDI  R26,LOW(16)
	CALL _lcd_init
; 0000 0065  lcd_clear();
	CALL SUBOPT_0x0
; 0000 0066  lcd_putsf("RFID DOOR SEC");
; 0000 0067 
; 0000 0068  i2c_init();
	CALL _i2c_init
; 0000 0069  rtc_init(0,0,0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	LDI  R26,LOW(0)
	CALL _rtc_init
; 0000 006A  rtc_set_time(12,0,0);
	LDI  R30,LOW(12)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(0)
	CALL _rtc_set_time
; 0000 006B  rtc_set_date(2,1,2,11);
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R26,LOW(11)
	CALL _rtc_set_date
; 0000 006C 
; 0000 006D  LED1=1;
	SBI  0x18,3
; 0000 006E  delay_ms(150);
	LDI  R26,LOW(150)
	CALL SUBOPT_0x1
; 0000 006F  LED1=0;
	CBI  0x18,3
; 0000 0070 
; 0000 0071  GSM_POWER_ON=1;
	SBI  0x12,3
; 0000 0072  delay_ms(1000);
	LDI  R26,LOW(1000)
	LDI  R27,HIGH(1000)
	CALL _delay_ms
; 0000 0073  GSM_POWER_ON=0;
	CBI  0x12,3
; 0000 0074 
; 0000 0075  #asm("sei")
	sei
; 0000 0076     while(1){
_0xC:
; 0000 0077 
; 0000 0078 
; 0000 0079 
; 0000 007A     if(get_keypad()==show_rfid_keypad_num){ // goto to show saved rfid if...
	RCALL _get_keypad
	CPI  R30,LOW(0xD)
	BRNE _0xF
; 0000 007B 
; 0000 007C      show_saved_rfid(); }
	RCALL _show_saved_rfid
; 0000 007D 
; 0000 007E 
; 0000 007F      if(get_keypad()== Time_setting_keypad_num){ // goto to Time setting if...
_0xF:
	RCALL _get_keypad
	CPI  R30,LOW(0xE)
	BRNE _0x10
; 0000 0080 
; 0000 0081      time_setting(); }
	RCALL _time_setting
; 0000 0082 
; 0000 0083      if(get_keypad()== new_rfid_keypad_num){ // goto to new card  if...
_0x10:
	RCALL _get_keypad
	CPI  R30,LOW(0xF)
	BRNE _0x11
; 0000 0084 
; 0000 0085      new_rfid_card(); }
	RCALL _new_rfid_card
; 0000 0086 
; 0000 0087 
; 0000 0088    if(get_keypad()== show_time_keypad_num){ // goto to show time...
_0x11:
	RCALL _get_keypad
	CPI  R30,LOW(0x10)
	BRNE _0x12
; 0000 0089 
; 0000 008A      show_time_and_date(); }
	RCALL _show_time_and_date
; 0000 008B 
; 0000 008C 
; 0000 008D       if(Index==10){//RFID Ready in Buffer
_0x12:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CP   R30,R4
	CPC  R31,R5
	BREQ PC+3
	JMP _0x13
; 0000 008E          for(i=0;i<10;i++){
	LDI  R17,LOW(0)
_0x15:
	CPI  R17,10
	BRSH _0x16
; 0000 008F          temp_buff[i]=Buff[i];
	CALL SUBOPT_0x2
	MOVW R26,R28
	CALL SUBOPT_0x3
; 0000 0090          }
	SUBI R17,-1
	RJMP _0x15
_0x16:
; 0000 0091        lcd_clear();
	CALL SUBOPT_0x4
; 0000 0092        lcd_putsf("ID=");
; 0000 0093        lcd_puts(temp_buff);
	CALL SUBOPT_0x5
; 0000 0094 
; 0000 0095       val= valid_check_rfid(temp_buff);
	MOVW R26,R28
	RCALL _valid_check_rfid
	MOV  R16,R30
; 0000 0096           if(val==1){
	CPI  R16,1
	BRNE _0x17
; 0000 0097                RELAY=1;
	SBI  0x18,2
; 0000 0098                BUZZER=0;//valid rfid can stop buzzer alarm
	CBI  0x15,0
; 0000 0099                lcd_clear();
	CALL SUBOPT_0x6
; 0000 009A                lcd_putsf(" Sending SMS ");
; 0000 009B                printf("AT%c",13);
; 0000 009C                delay_ms(200);
; 0000 009D                printf("AT+CMGF=1%c",13);
	CALL SUBOPT_0x7
; 0000 009E                delay_ms(200);
; 0000 009F                printf("AT+CMGS=%c09194176015%c%c",34,34,13); //  sms
	CALL SUBOPT_0x8
; 0000 00A0                delay_ms(200);
; 0000 00A1                putsf("ok ID=");
	__POINTW2FN _0x0,75
	RJMP _0xA2
; 0000 00A2               puts(temp_buff);
; 0000 00A3               printf("%d:%d:%d %d/%d/%d/" ,hour,min,sec,day,month,2000+year);
; 0000 00A4                printf("%c%c",13,26);
; 0000 00A5 
; 0000 00A6 
; 0000 00A7 
; 0000 00A8                delay_ms(100);
; 0000 00A9                lcd_clear();
; 0000 00AA                lcd_putsf("SMS SENT   ");
; 0000 00AB                delay_ms(200);
; 0000 00AC                lcd_clear();
; 0000 00AD                lcd_putsf("RFID DOOR SEC");
; 0000 00AE           }else //failed
_0x17:
; 0000 00AF           {
; 0000 00B0            lcd_clear();
	CALL _lcd_clear
; 0000 00B1                lcd_putsf("Wrong card");
	__POINTW2FN _0x0,113
	CALL SUBOPT_0x9
; 0000 00B2                delay_ms(600);
; 0000 00B3                lcd_clear();
; 0000 00B4                lcd_putsf("RFID DOOR SEC");
; 0000 00B5                RELAY=0;
	CBI  0x18,2
; 0000 00B6                fail_count++;
	SUBI R19,-1
; 0000 00B7                if(fail_count>3){//
	CPI  R19,4
	BRLO _0x1F
; 0000 00B8                BUZZER=1;
	SBI  0x15,0
; 0000 00B9                fail_count=0;
	LDI  R19,LOW(0)
; 0000 00BA                lcd_clear();
	CALL SUBOPT_0x6
; 0000 00BB                    lcd_putsf(" Sending SMS ");
; 0000 00BC                    printf("AT%c",13);
; 0000 00BD                    delay_ms(200);
; 0000 00BE                    printf("AT+CMGF=1%c",13);
	CALL SUBOPT_0x7
; 0000 00BF                    delay_ms(200);
; 0000 00C0                    printf("AT+CMGS=%c09194176015%c%c",34,34,13); //  sms  // +98 9194176015
	CALL SUBOPT_0x8
; 0000 00C1                    delay_ms(200);
; 0000 00C2                      putsf("Error ID=");
	__POINTW2FN _0x0,124
_0xA2:
	CALL _putsf
; 0000 00C3               puts(temp_buff);
	MOVW R26,R28
	CALL _puts
; 0000 00C4               printf("%d:%d:%d %d/%d/%d/" ,hour,min,sec,day,month,2000+year);
	__POINTW1FN _0x0,82
	CALL SUBOPT_0xA
	CALL SUBOPT_0xB
	CALL SUBOPT_0xC
	LDI  R24,24
	CALL _printf
	ADIW R28,26
; 0000 00C5                printf("%c%c",13,26);
	__POINTW1FN _0x0,70
	ST   -Y,R31
	ST   -Y,R30
	__GETD1N 0xD
	CALL __PUTPARD1
	__GETD1N 0x1A
	CALL __PUTPARD1
	LDI  R24,8
	CALL _printf
	ADIW R28,10
; 0000 00C6                    delay_ms(100);
	LDI  R26,LOW(100)
	CALL SUBOPT_0x1
; 0000 00C7                    lcd_clear();
	CALL _lcd_clear
; 0000 00C8                    lcd_putsf("SMS SENT   ");
	__POINTW2FN _0x0,101
	CALL _lcd_putsf
; 0000 00C9                    delay_ms(200);
	LDI  R26,LOW(200)
	CALL SUBOPT_0x1
; 0000 00CA                    lcd_clear();
	CALL SUBOPT_0x0
; 0000 00CB                  lcd_putsf("RFID DOOR SEC");
; 0000 00CC                }
; 0000 00CD           }
_0x1F:
; 0000 00CE       Index=0;//Clear Buffer Index
	CLR  R4
	CLR  R5
; 0000 00CF       }
; 0000 00D0 
; 0000 00D1 
; 0000 00D2       }
_0x13:
	RJMP _0xC
; 0000 00D3    }
_0x22:
	RJMP _0x22
;
; // USART Receiver interrupt service routine
;interrupt [USART_RXC] void usart_rx_isr(void)
; 0000 00D7 {
_usart_rx_isr:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 00D8 char status,data;
; 0000 00D9 status=UCSRA;
	ST   -Y,R17
	ST   -Y,R16
;	status -> R17
;	data -> R16
	IN   R17,11
; 0000 00DA data=UDR;
	IN   R16,12
; 0000 00DB #asm("cli")
	cli
; 0000 00DC if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
	MOV  R30,R17
	ANDI R30,LOW(0x1C)
	BRNE _0x23
; 0000 00DD    {
; 0000 00DE    Buff[Index]=data;
	MOVW R30,R4
	SUBI R30,LOW(-_Buff)
	SBCI R31,HIGH(-_Buff)
	ST   Z,R16
; 0000 00DF    Index++;
	MOVW R30,R4
	ADIW R30,1
	MOVW R4,R30
; 0000 00E0    }
; 0000 00E1     LED2=~LED2;
_0x23:
	SBIS 0x18,4
	RJMP _0x24
	CBI  0x18,4
	RJMP _0x25
_0x24:
	SBI  0x18,4
_0x25:
; 0000 00E2 
; 0000 00E3  #asm("sei")
	sei
; 0000 00E4 }
	LD   R16,Y+
	LD   R17,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
;//-------------valid check rfid------------------------------
;unsigned char valid_check_rfid(char* id_buffer)
; 0000 00E7 {
_valid_check_rfid:
	PUSH R15
; 0000 00E8 
; 0000 00E9 bit flg = 0 ;
; 0000 00EA char i=0;
; 0000 00EB  lcd_clear();
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
;	*id_buffer -> Y+1
;	flg -> R15.0
;	i -> R17
	CLR  R15
	LDI  R17,0
	CALL SUBOPT_0x0
; 0000 00EC  lcd_putsf("RFID DOOR SEC");
; 0000 00ED   delay_ms(30);
	LDI  R26,LOW(30)
	CALL SUBOPT_0x1
; 0000 00EE 
; 0000 00EF    for(i=0;i<10;i++){
	LDI  R17,LOW(0)
_0x27:
	CPI  R17,10
	BRSH _0x28
; 0000 00F0       if(id_buffer[i]!=saved_rfid_1[i]){
	CALL SUBOPT_0xD
	SUBI R26,LOW(-_saved_rfid_1)
	SBCI R27,HIGH(-_saved_rfid_1)
	CALL __EEPROMRDB
	CP   R30,R0
	BREQ _0x29
; 0000 00F1       flg=1 ;
	SET
	BLD  R15,0
; 0000 00F2       break ;
	RJMP _0x28
; 0000 00F3     }
; 0000 00F4   }
_0x29:
	SUBI R17,-1
	RJMP _0x27
_0x28:
; 0000 00F5 
; 0000 00F6    if (flg)
	SBRS R15,0
	RJMP _0x2A
; 0000 00F7     {
; 0000 00F8      for(i=0;i<10;i++){
	LDI  R17,LOW(0)
_0x2C:
	CPI  R17,10
	BRSH _0x2D
; 0000 00F9         if(id_buffer[i]!=saved_rfid_2[i]){
	CALL SUBOPT_0xD
	SUBI R26,LOW(-_saved_rfid_2)
	SBCI R27,HIGH(-_saved_rfid_2)
	CALL __EEPROMRDB
	CP   R30,R0
	BREQ _0x2E
; 0000 00FA         return 0 ;
	LDI  R30,LOW(0)
	RJMP _0x20C0009
; 0000 00FB         }
; 0000 00FC       }
_0x2E:
	SUBI R17,-1
	RJMP _0x2C
_0x2D:
; 0000 00FD      }
; 0000 00FE return 1 ;
_0x2A:
	LDI  R30,LOW(1)
_0x20C0009:
	LDD  R17,Y+0
	ADIW R28,3
	POP  R15
	RET
; 0000 00FF 
; 0000 0100 }
;//end of cali check rfid fuction -------
;
;///----get keypad -------------------
;
;  unsigned char get_keypad(void){
; 0000 0105 unsigned char get_keypad(void){
_get_keypad:
; 0000 0106   unsigned char key=0, butnum;
; 0000 0107 
; 0000 0108   DDRA = 0x0f;
	ST   -Y,R17
	ST   -Y,R16
;	key -> R17
;	butnum -> R16
	LDI  R17,0
	LDI  R30,LOW(15)
	OUT  0x1A,R30
; 0000 0109   PORTA = 0xf0;
	LDI  R30,LOW(240)
	OUT  0x1B,R30
; 0000 010A   delay_us(5);
	__DELAY_USB 13
; 0000 010B   key = PINA;
	IN   R17,25
; 0000 010C   DDRA = 0xf0;
	OUT  0x1A,R30
; 0000 010D   PORTA = 0x0f;
	LDI  R30,LOW(15)
	OUT  0x1B,R30
; 0000 010E   delay_us(5);
	__DELAY_USB 13
; 0000 010F   key = key | PINA;
	IN   R30,0x19
	OR   R17,R30
; 0000 0110   delay_us(5);
	__DELAY_USB 13
; 0000 0111 
; 0000 0112     if (key != 0xff)
	CPI  R17,255
	BREQ _0x2F
; 0000 0113    {
; 0000 0114      for (butnum=0; butnum<16; butnum++) {
	LDI  R16,LOW(0)
_0x31:
	CPI  R16,16
	BRSH _0x32
; 0000 0115      if (keytbl[butnum]==key) break;
	MOV  R30,R16
	LDI  R31,0
	SUBI R30,LOW(-_keytbl*2)
	SBCI R31,HIGH(-_keytbl*2)
	LPM  R26,Z
	CP   R17,R26
	BREQ _0x32
; 0000 0116     }
	SUBI R16,-1
	RJMP _0x31
_0x32:
; 0000 0117 
; 0000 0118     butnum++;
	SUBI R16,-1
; 0000 0119     }
; 0000 011A    else butnum=100;
	RJMP _0x34
_0x2F:
	LDI  R16,LOW(100)
; 0000 011B    return butnum;
_0x34:
	MOV  R30,R16
	RJMP _0x20C0008
; 0000 011C   }
;  //-----end of get keypad function------------
;
;  //---get number ----
;  /***this function use get_keypad() function and gets 2 digit integer  ***/
;   unsigned char get_number(void){
; 0000 0121 unsigned char get_number(void){
_get_number:
; 0000 0122    unsigned char z,x,y,buff[16];  // x is first num y is second and then our num=(x*10)+y
; 0000 0123    aval:
	SBIW R28,16
	CALL __SAVELOCR4
;	z -> R17
;	x -> R16
;	y -> R19
;	buff -> Y+4
_0x35:
; 0000 0124   do{
_0x37:
; 0000 0125    x=get_keypad();
	RCALL _get_keypad
	MOV  R16,R30
; 0000 0126    if(x==10){x=0;}
	CPI  R16,10
	BRNE _0x39
	LDI  R16,LOW(0)
; 0000 0127    if(x>10){x=100;}
_0x39:
	CPI  R16,11
	BRLO _0x3A
	LDI  R16,LOW(100)
; 0000 0128    }while(x==100);
_0x3A:
	CPI  R16,100
	BREQ _0x37
; 0000 0129 
; 0000 012A    do{
_0x3C:
; 0000 012B    z=get_keypad();
	RCALL _get_keypad
	MOV  R17,R30
; 0000 012C    }while(z !=100);
	CPI  R17,100
	BRNE _0x3C
; 0000 012D 
; 0000 012E    delay_ms(40);
	LDI  R26,LOW(40)
	CALL SUBOPT_0x1
; 0000 012F    lcd_gotoxy(0,1);
	CALL SUBOPT_0xE
; 0000 0130    sprintf(buff,"%d",x);
; 0000 0131    lcd_puts(buff);
; 0000 0132    delay_ms(40);
	LDI  R26,LOW(40)
	CALL SUBOPT_0x1
; 0000 0133 
; 0000 0134    do{
_0x3F:
; 0000 0135    y=get_keypad();
	RCALL _get_keypad
	MOV  R19,R30
; 0000 0136    if(y==10){y=0;}
	CPI  R19,10
	BRNE _0x41
	LDI  R19,LOW(0)
; 0000 0137    if(y>12){y=100;}
_0x41:
	CPI  R19,13
	BRLO _0x42
	LDI  R19,LOW(100)
; 0000 0138    }while(y==100);
_0x42:
	CPI  R19,100
	BREQ _0x3F
; 0000 0139 
; 0000 013A    do{
_0x44:
; 0000 013B    z=get_keypad();
	RCALL _get_keypad
	MOV  R17,R30
; 0000 013C    }while(z !=100);
	CPI  R17,100
	BRNE _0x44
; 0000 013D 
; 0000 013E    if(x<10){
	CPI  R16,10
	BRSH _0x46
; 0000 013F     if(y<10){
	CPI  R19,10
	BRSH _0x47
; 0000 0140     x*=10;
	LDI  R26,LOW(10)
	MULS R16,R26
	MOV  R16,R0
; 0000 0141     x=x+y;
	ADD  R16,R19
; 0000 0142     }
; 0000 0143    }
_0x47:
; 0000 0144    lcd_gotoxy(0,1);
_0x46:
	CALL SUBOPT_0xE
; 0000 0145    sprintf(buff,"%d",x);
; 0000 0146    lcd_puts(buff);
; 0000 0147 
; 0000 0148    while(1){
_0x48:
; 0000 0149    if(y==11){ return x;} //enter pressed
	CPI  R19,11
	BRNE _0x4B
	MOV  R30,R16
	CALL __LOADLOCR4
	JMP  _0x20C0004
; 0000 014A    if(y==12){ //corect pressed
_0x4B:
	CPI  R19,12
	BRNE _0x4C
; 0000 014B    lcd_gotoxy(0,1);
	CALL SUBOPT_0xF
; 0000 014C    lcd_putsf("  ");
	CALL SUBOPT_0x10
; 0000 014D    goto aval;}
	RJMP _0x35
; 0000 014E    y=get_keypad();
_0x4C:
	RCALL _get_keypad
	MOV  R19,R30
; 0000 014F    }
	RJMP _0x48
; 0000 0150   }
;  //---end of get number function
;  //---get_pass function-----
;  unsigned int get_pass(void){//this function will get 4 digits pass from admin
; 0000 0153 unsigned int get_pass(void){
_get_pass:
; 0000 0154   unsigned char digit1;
; 0000 0155   unsigned char sens_for_edge;
; 0000 0156  // char temp_lcd_buffer[17];
; 0000 0157 
; 0000 0158 
; 0000 0159    do{  //get digit 1
	ST   -Y,R17
	ST   -Y,R16
;	digit1 -> R17
;	sens_for_edge -> R16
_0x4E:
; 0000 015A    digit1=get_keypad();
	CALL SUBOPT_0x11
; 0000 015B    if(digit1==10){digit1=0;}
	BRNE _0x50
	LDI  R17,LOW(0)
; 0000 015C    if(digit1>10){digit1=100;}
_0x50:
	CPI  R17,11
	BRLO _0x51
	LDI  R17,LOW(100)
; 0000 015D    }while(digit1==100);
_0x51:
	CPI  R17,100
	BREQ _0x4E
; 0000 015E 
; 0000 015F    do{  //wait until no button ...
_0x53:
; 0000 0160    sens_for_edge=get_keypad();
	RCALL _get_keypad
	MOV  R16,R30
; 0000 0161    }while(sens_for_edge!=100);
	CPI  R16,100
	BRNE _0x53
; 0000 0162 
; 0000 0163    pass[0]=digit1;
	STS  _pass,R17
; 0000 0164 
; 0000 0165    lcd_gotoxy(0,1);
	CALL SUBOPT_0xF
; 0000 0166    lcd_putsf("Pass=*");
	__POINTW2FN _0x0,137
	CALL _lcd_putsf
; 0000 0167 
; 0000 0168 
; 0000 0169    do{  //get digit 2
_0x56:
; 0000 016A    digit1=get_keypad();
	CALL SUBOPT_0x11
; 0000 016B    if(digit1==10){digit1=0;}
	BRNE _0x58
	LDI  R17,LOW(0)
; 0000 016C    if(digit1>10){digit1=100;}
_0x58:
	CPI  R17,11
	BRLO _0x59
	LDI  R17,LOW(100)
; 0000 016D    }while(digit1==100);
_0x59:
	CPI  R17,100
	BREQ _0x56
; 0000 016E 
; 0000 016F    do{  //wait until no button ...
_0x5B:
; 0000 0170    sens_for_edge=get_keypad();
	RCALL _get_keypad
	MOV  R16,R30
; 0000 0171    }while(sens_for_edge!=100);
	CPI  R16,100
	BRNE _0x5B
; 0000 0172 
; 0000 0173    pass[1]=digit1;
	__PUTBMRN _pass,1,17
; 0000 0174 
; 0000 0175    lcd_gotoxy(0,1);
	CALL SUBOPT_0xF
; 0000 0176    lcd_putsf("Pass=**");
	__POINTW2FN _0x0,144
	CALL _lcd_putsf
; 0000 0177 
; 0000 0178    do{  //get digit 3
_0x5E:
; 0000 0179    digit1=get_keypad();
	CALL SUBOPT_0x11
; 0000 017A    if(digit1==10){digit1=0;}
	BRNE _0x60
	LDI  R17,LOW(0)
; 0000 017B    if(digit1>10){digit1=100;}
_0x60:
	CPI  R17,11
	BRLO _0x61
	LDI  R17,LOW(100)
; 0000 017C    }while(digit1==100);
_0x61:
	CPI  R17,100
	BREQ _0x5E
; 0000 017D 
; 0000 017E    do{  //wait until no button ...
_0x63:
; 0000 017F    sens_for_edge=get_keypad();
	RCALL _get_keypad
	MOV  R16,R30
; 0000 0180    }while(sens_for_edge!=100);
	CPI  R16,100
	BRNE _0x63
; 0000 0181 
; 0000 0182    pass[2]=digit1;
	__PUTBMRN _pass,2,17
; 0000 0183 
; 0000 0184    lcd_gotoxy(0,1);
	CALL SUBOPT_0xF
; 0000 0185    lcd_putsf("Pass=***");
	__POINTW2FN _0x0,152
	CALL _lcd_putsf
; 0000 0186 
; 0000 0187     do{  //get digit 4
_0x66:
; 0000 0188    digit1=get_keypad();
	CALL SUBOPT_0x11
; 0000 0189    if(digit1==10){digit1=0;}
	BRNE _0x68
	LDI  R17,LOW(0)
; 0000 018A    if(digit1>10){digit1=100;}
_0x68:
	CPI  R17,11
	BRLO _0x69
	LDI  R17,LOW(100)
; 0000 018B    }while(digit1==100);
_0x69:
	CPI  R17,100
	BREQ _0x66
; 0000 018C 
; 0000 018D    do{  //wait until no button ...
_0x6B:
; 0000 018E    sens_for_edge=get_keypad();
	RCALL _get_keypad
	MOV  R16,R30
; 0000 018F    }while(sens_for_edge!=100);
	CPI  R16,100
	BRNE _0x6B
; 0000 0190 
; 0000 0191    pass[3]=digit1;
	__PUTBMRN _pass,3,17
; 0000 0192    lcd_gotoxy(0,1);
	CALL SUBOPT_0xF
; 0000 0193   lcd_putsf("Pass=****");
	__POINTW2FN _0x0,161
	CALL _lcd_putsf
; 0000 0194 
; 0000 0195    return 0;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
_0x20C0008:
	LD   R16,Y+
	LD   R17,Y+
	RET
; 0000 0196 
; 0000 0197   }
;  //---end of get pass function-----
;
;
;  //unsigned char hour,min,sec,week_day,day,month,year;
;  //---time and date setting function -----
;
;  void time_setting(void){
; 0000 019E void time_setting(void){
_time_setting:
; 0000 019F   unsigned char buff[16];
; 0000 01A0   lcd_clear();
	SBIW R28,16
;	buff -> Y+0
	CALL _lcd_clear
; 0000 01A1   lcd_putsf("Set system Time");
	__POINTW2FN _0x0,171
	CALL SUBOPT_0x12
; 0000 01A2   lcd_gotoxy(5,1);
; 0000 01A3   sprintf(buff,"??:%d:%d",min,sec);
	__POINTW1FN _0x0,187
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0xB
	CALL SUBOPT_0x13
; 0000 01A4   lcd_puts(buff);
; 0000 01A5    do{
_0x6E:
; 0000 01A6    lcd_gotoxy(0,1);
	CALL SUBOPT_0xF
; 0000 01A7    lcd_putsf("  ");
	CALL SUBOPT_0x10
; 0000 01A8    hour=get_number();
	RCALL _get_number
	MOV  R7,R30
; 0000 01A9    }while(hour>23);
	LDI  R30,LOW(23)
	CP   R30,R7
	BRLO _0x6E
; 0000 01AA    lcd_clear();
	CALL _lcd_clear
; 0000 01AB 
; 0000 01AC   lcd_putsf("set system Time");
	__POINTW2FN _0x0,196
	CALL SUBOPT_0x12
; 0000 01AD   lcd_gotoxy(5,1);
; 0000 01AE   sprintf(buff,"%d:??:%d",hour,sec);
	__POINTW1FN _0x0,212
	CALL SUBOPT_0xA
	MOV  R30,R9
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	CALL SUBOPT_0x13
; 0000 01AF   lcd_puts(buff);
; 0000 01B0    do{
_0x71:
; 0000 01B1    lcd_gotoxy(0,1);
	CALL SUBOPT_0xF
; 0000 01B2    lcd_putsf("  ");
	CALL SUBOPT_0x10
; 0000 01B3    min=get_number();
	RCALL _get_number
	MOV  R6,R30
; 0000 01B4    }while(min>59);
	LDI  R30,LOW(59)
	CP   R30,R6
	BRLO _0x71
; 0000 01B5    lcd_clear();
	CALL SUBOPT_0x14
; 0000 01B6 
; 0000 01B7 
; 0000 01B8   lcd_putsf("Set system date"); //day
; 0000 01B9   lcd_gotoxy(5,1);
; 0000 01BA   sprintf(buff,"??/%02d/%02d",day,month,2000+year);
	__POINTW1FN _0x0,237
	CALL SUBOPT_0x15
	CALL SUBOPT_0x16
; 0000 01BB   lcd_puts(buff);
; 0000 01BC    do{
_0x74:
; 0000 01BD    lcd_gotoxy(0,1);
	CALL SUBOPT_0xF
; 0000 01BE    lcd_putsf("  ");
	CALL SUBOPT_0x10
; 0000 01BF    day=get_number();
	RCALL _get_number
	MOV  R11,R30
; 0000 01C0    }while(day>31);
	LDI  R30,LOW(31)
	CP   R30,R11
	BRLO _0x74
; 0000 01C1    lcd_clear();
	CALL SUBOPT_0x14
; 0000 01C2 
; 0000 01C3    lcd_putsf("Set system date"); //month
; 0000 01C4   lcd_gotoxy(5,1);
; 0000 01C5   sprintf(buff,"%02d/??/%d",day,month,2000+year);
	__POINTW1FN _0x0,250
	CALL SUBOPT_0x15
	CALL SUBOPT_0x16
; 0000 01C6   lcd_puts(buff);
; 0000 01C7    do{
_0x77:
; 0000 01C8    lcd_gotoxy(0,1);
	CALL SUBOPT_0xF
; 0000 01C9    lcd_putsf("  ");
	CALL SUBOPT_0x10
; 0000 01CA    month=get_number();
	RCALL _get_number
	MOV  R10,R30
; 0000 01CB    }while(month>12);
	LDI  R30,LOW(12)
	CP   R30,R10
	BRLO _0x77
; 0000 01CC    lcd_clear();
	CALL SUBOPT_0x14
; 0000 01CD 
; 0000 01CE    lcd_putsf("Set system date"); //year
; 0000 01CF   lcd_gotoxy(5,1);
; 0000 01D0   sprintf(buff,"%02d/%02d/20??",day,month,2000+year);
	__POINTW1FN _0x0,261
	CALL SUBOPT_0x15
	CALL SUBOPT_0x16
; 0000 01D1   lcd_puts(buff);
; 0000 01D2    do{
_0x7A:
; 0000 01D3    lcd_gotoxy(0,1);
	CALL SUBOPT_0xF
; 0000 01D4    lcd_putsf("  ");
	CALL SUBOPT_0x10
; 0000 01D5    year=get_number();
	RCALL _get_number
	MOV  R13,R30
; 0000 01D6    }while(year>99);
	LDI  R30,LOW(99)
	CP   R30,R13
	BRLO _0x7A
; 0000 01D7 
; 0000 01D8 
; 0000 01D9    rtc_set_time(hour,min,0);
	ST   -Y,R7
	ST   -Y,R6
	LDI  R26,LOW(0)
	CALL _rtc_set_time
; 0000 01DA    rtc_set_date(1,day,month,year);
	LDI  R30,LOW(1)
	ST   -Y,R30
	ST   -Y,R11
	ST   -Y,R10
	MOV  R26,R13
	CALL _rtc_set_date
; 0000 01DB     lcd_clear();
	RCALL _lcd_clear
; 0000 01DC   show_time_and_date();
	RCALL _show_time_and_date
; 0000 01DD 
; 0000 01DE   }
	ADIW R28,16
	RET
;  //---end of time and date setting
;
;   //-----show saved rfid function -----
;  unsigned char show_saved_rfid(void){
; 0000 01E2 unsigned char show_saved_rfid(void){
_show_saved_rfid:
; 0000 01E3   char temp_buff_3[11],temp_buff_4[11];
; 0000 01E4   unsigned char i;
; 0000 01E5   lcd_clear();
	SBIW R28,22
	ST   -Y,R17
;	temp_buff_3 -> Y+12
;	temp_buff_4 -> Y+1
;	i -> R17
	CALL SUBOPT_0x17
; 0000 01E6   lcd_putsf("Enter Password:");
; 0000 01E7   get_pass();
; 0000 01E8    if(pass[0]==saved_pass[0] && pass[1]==saved_pass[1]
; 0000 01E9    && pass[2]==saved_pass[2] && pass[3]==saved_pass[3]){
	BRNE _0x7D
	__GETB2MN _pass,1
	__GETB1MN _saved_pass,1
	CP   R30,R26
	BRNE _0x7D
	__GETB2MN _pass,2
	__GETB1MN _saved_pass,2
	CP   R30,R26
	BRNE _0x7D
	__GETB2MN _pass,3
	__GETB1MN _saved_pass,3
	CP   R30,R26
	BREQ _0x7E
_0x7D:
	RJMP _0x7C
_0x7E:
; 0000 01EA 
; 0000 01EB      for(i=0;i<10;i++){
	LDI  R17,LOW(0)
_0x80:
	CPI  R17,10
	BRSH _0x81
; 0000 01EC       temp_buff_3[i] = saved_rfid_1[i];
	CALL SUBOPT_0x2
	MOVW R26,R28
	ADIW R26,12
	CALL SUBOPT_0x18
	SUBI R26,LOW(-_saved_rfid_1)
	SBCI R27,HIGH(-_saved_rfid_1)
	CALL __EEPROMRDB
	MOVW R26,R0
	ST   X,R30
; 0000 01ED      }
	SUBI R17,-1
	RJMP _0x80
_0x81:
; 0000 01EE      for(i=0;i<10;i++){
	LDI  R17,LOW(0)
_0x83:
	CPI  R17,10
	BRSH _0x84
; 0000 01EF       temp_buff_4[i] = saved_rfid_2[i];
	CALL SUBOPT_0x2
	MOVW R26,R28
	ADIW R26,1
	CALL SUBOPT_0x18
	SUBI R26,LOW(-_saved_rfid_2)
	SBCI R27,HIGH(-_saved_rfid_2)
	CALL __EEPROMRDB
	MOVW R26,R0
	ST   X,R30
; 0000 01F0      }
	SUBI R17,-1
	RJMP _0x83
_0x84:
; 0000 01F1     lcd_clear();
	RCALL _lcd_clear
; 0000 01F2     lcd_puts(&temp_buff_3[0]);
	MOVW R26,R28
	ADIW R26,12
	RCALL _lcd_puts
; 0000 01F3     delay_ms(1);
	LDI  R26,LOW(1)
	CALL SUBOPT_0x1
; 0000 01F4     lcd_gotoxy(0,1);
	CALL SUBOPT_0xF
; 0000 01F5     lcd_puts(&temp_buff_4[0]);
	MOVW R26,R28
	ADIW R26,1
	RCALL _lcd_puts
; 0000 01F6 
; 0000 01F7     while(get_keypad()!=show_rfid_keypad_num);// if show button pushed exit
_0x85:
	RCALL _get_keypad
	CPI  R30,LOW(0xD)
	BRNE _0x85
; 0000 01F8      while(get_keypad()==show_rfid_keypad_num);//debuonce
_0x88:
	RCALL _get_keypad
	CPI  R30,LOW(0xD)
	BREQ _0x88
; 0000 01F9       lcd_clear();
	CALL SUBOPT_0x0
; 0000 01FA  lcd_putsf("RFID DOOR SEC");
; 0000 01FB    }
; 0000 01FC      else{
	RJMP _0x8B
_0x7C:
; 0000 01FD      lcd_clear();
	RCALL _lcd_clear
; 0000 01FE       lcd_putsf("wrong Pass");
	__POINTW2FN _0x0,292
	RCALL _lcd_putsf
; 0000 01FF       delay_ms(500);
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
	CALL _delay_ms
; 0000 0200       lcd_clear();
	CALL SUBOPT_0x0
; 0000 0201  lcd_putsf("RFID DOOR SEC");
; 0000 0202      return 0;
	LDI  R30,LOW(0)
; 0000 0203      }
_0x8B:
; 0000 0204   }
_0x20C0007:
	LDD  R17,Y+0
	ADIW R28,23
	RET
;  //-----end of show saved rfid function-----
;
;    //----- save new rfid card function -----
;  unsigned char new_rfid_card(void){
; 0000 0208 unsigned char new_rfid_card(void){
_new_rfid_card:
; 0000 0209   unsigned char i,flash_number=1;
; 0000 020A   char temp_buff_2[11];
; 0000 020B   lcd_clear();
	SBIW R28,11
	ST   -Y,R17
	ST   -Y,R16
;	i -> R17
;	flash_number -> R16
;	temp_buff_2 -> Y+2
	LDI  R16,1
	CALL SUBOPT_0x17
; 0000 020C   lcd_putsf("Enter Password:");
; 0000 020D   get_pass();
; 0000 020E    if(pass[0]==saved_pass[0] && pass[1]==saved_pass[1]
; 0000 020F    && pass[2]==saved_pass[2] && pass[3]==saved_pass[3]){
	BRNE _0x8D
	__GETB2MN _pass,1
	__GETB1MN _saved_pass,1
	CP   R30,R26
	BRNE _0x8D
	__GETB2MN _pass,2
	__GETB1MN _saved_pass,2
	CP   R30,R26
	BRNE _0x8D
	__GETB2MN _pass,3
	__GETB1MN _saved_pass,3
	CP   R30,R26
	BREQ _0x8E
_0x8D:
	RJMP _0x8C
_0x8E:
; 0000 0210 
; 0000 0211    lcd_clear();
	RCALL _lcd_clear
; 0000 0212    lcd_putsf("Enter 1 or 2 ?"); //flash_number
	__POINTW2FN _0x0,303
	RCALL _lcd_putsf
; 0000 0213    do{
_0x90:
; 0000 0214    lcd_gotoxy(0,1);
	CALL SUBOPT_0xF
; 0000 0215    lcd_putsf("  ");
	CALL SUBOPT_0x10
; 0000 0216    flash_number=get_number();
	RCALL _get_number
	MOV  R16,R30
; 0000 0217    }while(flash_number>2);
	CPI  R16,3
	BRSH _0x90
; 0000 0218 
; 0000 0219 
; 0000 021A    lcd_clear();
	RCALL _lcd_clear
; 0000 021B    lcd_putsf("close card");
	__POINTW2FN _0x0,318
	RCALL _lcd_putsf
; 0000 021C 
; 0000 021D    while(get_keypad()!=new_rfid_keypad_num){
_0x92:
	RCALL _get_keypad
	CPI  R30,LOW(0xF)
	BRNE PC+3
	JMP _0x94
; 0000 021E 
; 0000 021F      if(Index==10){//RFID Ready in Buffer
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CP   R30,R4
	CPC  R31,R5
	BRNE _0x95
; 0000 0220 
; 0000 0221        if(flash_number==2){
	CPI  R16,2
	BRNE _0x96
; 0000 0222        for(i=0;i<10;i++){  //0-9 +null
	LDI  R17,LOW(0)
_0x98:
	CPI  R17,10
	BRSH _0x99
; 0000 0223          temp_buff_2[i]=Buff[i];
	CALL SUBOPT_0x2
	MOVW R26,R28
	ADIW R26,2
	CALL SUBOPT_0x3
; 0000 0224          saved_rfid_1[i]=Buff[i];
	MOV  R26,R17
	LDI  R27,0
	SUBI R26,LOW(-_saved_rfid_1)
	SBCI R27,HIGH(-_saved_rfid_1)
	CALL SUBOPT_0x2
	SUBI R30,LOW(-_Buff)
	SBCI R31,HIGH(-_Buff)
	LD   R30,Z
	CALL __EEPROMWRB
; 0000 0225          }
	SUBI R17,-1
	RJMP _0x98
_0x99:
; 0000 0226 
; 0000 0227        }
; 0000 0228 
; 0000 0229         if(flash_number==1){
_0x96:
	CPI  R16,1
	BRNE _0x9A
; 0000 022A         for(i=0;i<10;i++){  //11
	LDI  R17,LOW(0)
_0x9C:
	CPI  R17,10
	BRSH _0x9D
; 0000 022B          temp_buff_2[i]=Buff[i];
	CALL SUBOPT_0x2
	MOVW R26,R28
	ADIW R26,2
	CALL SUBOPT_0x3
; 0000 022C          saved_rfid_2[i]=Buff[i];
	MOV  R26,R17
	LDI  R27,0
	SUBI R26,LOW(-_saved_rfid_2)
	SBCI R27,HIGH(-_saved_rfid_2)
	CALL SUBOPT_0x2
	SUBI R30,LOW(-_Buff)
	SBCI R31,HIGH(-_Buff)
	LD   R30,Z
	CALL __EEPROMWRB
; 0000 022D          }
	SUBI R17,-1
	RJMP _0x9C
_0x9D:
; 0000 022E        }
; 0000 022F 
; 0000 0230        lcd_clear();
_0x9A:
	CALL SUBOPT_0x4
; 0000 0231        lcd_putsf("ID=");
; 0000 0232        lcd_puts(temp_buff_2);
	MOVW R26,R28
	ADIW R26,2
	RCALL _lcd_puts
; 0000 0233       Index=0;//Clear Buffer Index
	CLR  R4
	CLR  R5
; 0000 0234 
; 0000 0235       }
; 0000 0236 
; 0000 0237      }
_0x95:
	RJMP _0x92
_0x94:
; 0000 0238      while(get_keypad()==new_rfid_keypad_num);//for debounce
_0x9E:
	RCALL _get_keypad
	CPI  R30,LOW(0xF)
	BREQ _0x9E
; 0000 0239      lcd_clear();
	CALL SUBOPT_0x0
; 0000 023A  lcd_putsf("RFID DOOR SEC");
; 0000 023B    }
; 0000 023C      else{
	RJMP _0xA1
_0x8C:
; 0000 023D      lcd_clear();
	RCALL _lcd_clear
; 0000 023E       lcd_putsf("wrong Pass");
	__POINTW2FN _0x0,292
	CALL SUBOPT_0x9
; 0000 023F       delay_ms(600);
; 0000 0240       lcd_clear();
; 0000 0241  lcd_putsf("RFID DOOR SEC");
; 0000 0242      return 0;
	LDI  R30,LOW(0)
; 0000 0243      }
_0xA1:
; 0000 0244   }
_0x20C0006:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,13
	RET
;  //-----end of save new rfid card function -----
;
;  ///------show time
;    void show_time_and_date(void){
; 0000 0248 void show_time_and_date(void){
_show_time_and_date:
; 0000 0249      char display_buffer[17],display_buffer2[17];
; 0000 024A     rtc_get_time(&hour,&min,&sec);
	SBIW R28,34
;	display_buffer -> Y+17
;	display_buffer2 -> Y+0
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(9)
	LDI  R27,HIGH(9)
	CALL _rtc_get_time
; 0000 024B 
; 0000 024C   rtc_get_date(&week_day,&day,&month,&year);
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(11)
	LDI  R31,HIGH(11)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(13)
	LDI  R27,HIGH(13)
	CALL _rtc_get_date
; 0000 024D 
; 0000 024E     sprintf(display_buffer,"Time: %2d:%02d:%02d",hour,min,sec);
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,329
	CALL SUBOPT_0xA
	CALL SUBOPT_0xB
	LDI  R24,12
	CALL _sprintf
	ADIW R28,16
; 0000 024F  sprintf(display_buffer2,"Date: %2d/%02d/%d",day,month,2000+year);
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,349
	CALL SUBOPT_0x15
	LDI  R24,12
	CALL _sprintf
	ADIW R28,16
; 0000 0250 
; 0000 0251     lcd_clear();
	RCALL _lcd_clear
; 0000 0252     lcd_puts(display_buffer);
	MOVW R26,R28
	ADIW R26,17
	RCALL _lcd_puts
; 0000 0253     delay_ms(3);
	LDI  R26,LOW(3)
	CALL SUBOPT_0x1
; 0000 0254     lcd_gotoxy(0,1);
	CALL SUBOPT_0xF
; 0000 0255     lcd_puts(display_buffer2);
	CALL SUBOPT_0x5
; 0000 0256     delay_ms(1000);
	LDI  R26,LOW(1000)
	LDI  R27,HIGH(1000)
	CALL _delay_ms
; 0000 0257     lcd_clear();
	CALL SUBOPT_0x0
; 0000 0258     lcd_putsf("RFID DOOR SEC");
; 0000 0259     }
	ADIW R28,34
	RET
;  //--end of show time
;
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.DSEG

	.CSEG
__lcd_write_nibble_G100:
	ST   -Y,R26
	LD   R30,Y
	ANDI R30,LOW(0x10)
	BREQ _0x2000004
	SBI  0x15,4
	RJMP _0x2000005
_0x2000004:
	CBI  0x15,4
_0x2000005:
	LD   R30,Y
	ANDI R30,LOW(0x20)
	BREQ _0x2000006
	SBI  0x15,3
	RJMP _0x2000007
_0x2000006:
	CBI  0x15,3
_0x2000007:
	LD   R30,Y
	ANDI R30,LOW(0x40)
	BREQ _0x2000008
	SBI  0x15,2
	RJMP _0x2000009
_0x2000008:
	CBI  0x15,2
_0x2000009:
	LD   R30,Y
	ANDI R30,LOW(0x80)
	BREQ _0x200000A
	SBI  0x15,1
	RJMP _0x200000B
_0x200000A:
	CBI  0x15,1
_0x200000B:
	__DELAY_USB 5
	SBI  0x15,5
	__DELAY_USB 13
	CBI  0x15,5
	__DELAY_USB 13
	JMP  _0x20C0005
__lcd_write_data:
	ST   -Y,R26
	LD   R26,Y
	RCALL __lcd_write_nibble_G100
    ld    r30,y
    swap  r30
    st    y,r30
	LD   R26,Y
	RCALL __lcd_write_nibble_G100
	__DELAY_USB 133
	RJMP _0x20C0005
_lcd_gotoxy:
	ST   -Y,R26
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G100)
	SBCI R31,HIGH(-__base_y_G100)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R26,R30
	RCALL __lcd_write_data
	LDD  R12,Y+1
	LD   R30,Y
	STS  __lcd_y,R30
	ADIW R28,2
	RET
_lcd_clear:
	LDI  R26,LOW(2)
	RCALL __lcd_write_data
	LDI  R26,LOW(3)
	CALL SUBOPT_0x1
	LDI  R26,LOW(12)
	RCALL __lcd_write_data
	LDI  R26,LOW(1)
	RCALL __lcd_write_data
	LDI  R26,LOW(3)
	CALL SUBOPT_0x1
	LDI  R30,LOW(0)
	STS  __lcd_y,R30
	MOV  R12,R30
	RET
_lcd_putchar:
	ST   -Y,R26
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BREQ _0x2000011
	LDS  R30,__lcd_maxx
	CP   R12,R30
	BRLO _0x2000010
_0x2000011:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDS  R26,__lcd_y
	SUBI R26,-LOW(1)
	STS  __lcd_y,R26
	RCALL _lcd_gotoxy
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BRNE _0x2000013
	RJMP _0x20C0005
_0x2000013:
_0x2000010:
	INC  R12
	SBI  0x15,7
	LD   R26,Y
	RCALL __lcd_write_data
	CBI  0x15,7
	RJMP _0x20C0005
_lcd_puts:
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
_0x2000014:
	CALL SUBOPT_0x19
	BREQ _0x2000016
	MOV  R26,R17
	RCALL _lcd_putchar
	RJMP _0x2000014
_0x2000016:
	LDD  R17,Y+0
	JMP  _0x20C0002
_lcd_putsf:
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
_0x2000017:
	CALL SUBOPT_0x1A
	BREQ _0x2000019
	MOV  R26,R17
	RCALL _lcd_putchar
	RJMP _0x2000017
_0x2000019:
	LDD  R17,Y+0
	JMP  _0x20C0002
_lcd_init:
	ST   -Y,R26
	SBI  0x14,4
	SBI  0x14,3
	SBI  0x14,2
	SBI  0x14,1
	SBI  0x14,5
	SBI  0x14,7
	SBI  0x14,6
	CBI  0x15,5
	CBI  0x15,7
	CBI  0x15,6
	LD   R30,Y
	STS  __lcd_maxx,R30
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G100,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G100,3
	LDI  R26,LOW(20)
	CALL SUBOPT_0x1
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x1B
	LDI  R26,LOW(32)
	RCALL __lcd_write_nibble_G100
	__DELAY_USW 200
	LDI  R26,LOW(40)
	RCALL __lcd_write_data
	LDI  R26,LOW(4)
	RCALL __lcd_write_data
	LDI  R26,LOW(133)
	RCALL __lcd_write_data
	LDI  R26,LOW(6)
	RCALL __lcd_write_data
	RCALL _lcd_clear
	RJMP _0x20C0005
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_putchar:
	ST   -Y,R26
putchar0:
     sbis usr,udre
     rjmp putchar0
     ld   r30,y
     out  udr,r30
_0x20C0005:
	ADIW R28,1
	RET
_puts:
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
_0x2020003:
	CALL SUBOPT_0x19
	BREQ _0x2020005
	MOV  R26,R17
	RCALL _putchar
	RJMP _0x2020003
_0x2020005:
	LDI  R26,LOW(10)
	RCALL _putchar
	LDD  R17,Y+0
	RJMP _0x20C0002
_putsf:
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
_0x2020006:
	CALL SUBOPT_0x1A
	BREQ _0x2020008
	MOV  R26,R17
	RCALL _putchar
	RJMP _0x2020006
_0x2020008:
	LDI  R26,LOW(10)
	RCALL _putchar
	LDD  R17,Y+0
	RJMP _0x20C0002
_put_usart_G101:
	ST   -Y,R27
	ST   -Y,R26
	LDD  R26,Y+2
	RCALL _putchar
	LD   R26,Y
	LDD  R27,Y+1
	CALL SUBOPT_0x1C
	RJMP _0x20C0002
_put_buff_G101:
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x2020010
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,4
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2020012
	__CPWRN 16,17,2
	BRLO _0x2020013
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	__PUTW1SNS 2,4
_0x2020012:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	CALL SUBOPT_0x1C
	SBIW R30,1
	LDD  R26,Y+4
	STD  Z+0,R26
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	TST  R31
	BRMI _0x2020014
	CALL SUBOPT_0x1C
_0x2020014:
_0x2020013:
	RJMP _0x2020015
_0x2020010:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	ST   X+,R30
	ST   X,R31
_0x2020015:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,5
	RET
__print_G101:
	ST   -Y,R27
	ST   -Y,R26
	SBIW R28,6
	CALL __SAVELOCR6
	LDI  R17,0
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
_0x2020016:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x2020018
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x202001C
	CPI  R18,37
	BRNE _0x202001D
	LDI  R17,LOW(1)
	RJMP _0x202001E
_0x202001D:
	CALL SUBOPT_0x1D
_0x202001E:
	RJMP _0x202001B
_0x202001C:
	CPI  R30,LOW(0x1)
	BRNE _0x202001F
	CPI  R18,37
	BRNE _0x2020020
	CALL SUBOPT_0x1D
	RJMP _0x20200C9
_0x2020020:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x2020021
	LDI  R16,LOW(1)
	RJMP _0x202001B
_0x2020021:
	CPI  R18,43
	BRNE _0x2020022
	LDI  R20,LOW(43)
	RJMP _0x202001B
_0x2020022:
	CPI  R18,32
	BRNE _0x2020023
	LDI  R20,LOW(32)
	RJMP _0x202001B
_0x2020023:
	RJMP _0x2020024
_0x202001F:
	CPI  R30,LOW(0x2)
	BRNE _0x2020025
_0x2020024:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x2020026
	ORI  R16,LOW(128)
	RJMP _0x202001B
_0x2020026:
	RJMP _0x2020027
_0x2020025:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x202001B
_0x2020027:
	CPI  R18,48
	BRLO _0x202002A
	CPI  R18,58
	BRLO _0x202002B
_0x202002A:
	RJMP _0x2020029
_0x202002B:
	LDI  R26,LOW(10)
	MUL  R21,R26
	MOV  R21,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x202001B
_0x2020029:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x202002F
	CALL SUBOPT_0x1E
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	LDD  R26,Z+4
	ST   -Y,R26
	CALL SUBOPT_0x1F
	RJMP _0x2020030
_0x202002F:
	CPI  R30,LOW(0x73)
	BRNE _0x2020032
	CALL SUBOPT_0x1E
	CALL SUBOPT_0x20
	CALL _strlen
	MOV  R17,R30
	RJMP _0x2020033
_0x2020032:
	CPI  R30,LOW(0x70)
	BRNE _0x2020035
	CALL SUBOPT_0x1E
	CALL SUBOPT_0x20
	CALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x2020033:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x2020036
_0x2020035:
	CPI  R30,LOW(0x64)
	BREQ _0x2020039
	CPI  R30,LOW(0x69)
	BRNE _0x202003A
_0x2020039:
	ORI  R16,LOW(4)
	RJMP _0x202003B
_0x202003A:
	CPI  R30,LOW(0x75)
	BRNE _0x202003C
_0x202003B:
	LDI  R30,LOW(_tbl10_G101*2)
	LDI  R31,HIGH(_tbl10_G101*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(5)
	RJMP _0x202003D
_0x202003C:
	CPI  R30,LOW(0x58)
	BRNE _0x202003F
	ORI  R16,LOW(8)
	RJMP _0x2020040
_0x202003F:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x2020071
_0x2020040:
	LDI  R30,LOW(_tbl16_G101*2)
	LDI  R31,HIGH(_tbl16_G101*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(4)
_0x202003D:
	SBRS R16,2
	RJMP _0x2020042
	CALL SUBOPT_0x1E
	CALL SUBOPT_0x21
	LDD  R26,Y+11
	TST  R26
	BRPL _0x2020043
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	CALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R20,LOW(45)
_0x2020043:
	CPI  R20,0
	BREQ _0x2020044
	SUBI R17,-LOW(1)
	RJMP _0x2020045
_0x2020044:
	ANDI R16,LOW(251)
_0x2020045:
	RJMP _0x2020046
_0x2020042:
	CALL SUBOPT_0x1E
	CALL SUBOPT_0x21
_0x2020046:
_0x2020036:
	SBRC R16,0
	RJMP _0x2020047
_0x2020048:
	CP   R17,R21
	BRSH _0x202004A
	SBRS R16,7
	RJMP _0x202004B
	SBRS R16,2
	RJMP _0x202004C
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x202004D
_0x202004C:
	LDI  R18,LOW(48)
_0x202004D:
	RJMP _0x202004E
_0x202004B:
	LDI  R18,LOW(32)
_0x202004E:
	CALL SUBOPT_0x1D
	SUBI R21,LOW(1)
	RJMP _0x2020048
_0x202004A:
_0x2020047:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x202004F
_0x2020050:
	CPI  R19,0
	BREQ _0x2020052
	SBRS R16,3
	RJMP _0x2020053
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LPM  R18,Z+
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP _0x2020054
_0x2020053:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R18,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x2020054:
	CALL SUBOPT_0x1D
	CPI  R21,0
	BREQ _0x2020055
	SUBI R21,LOW(1)
_0x2020055:
	SUBI R19,LOW(1)
	RJMP _0x2020050
_0x2020052:
	RJMP _0x2020056
_0x202004F:
_0x2020058:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
_0x202005A:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x202005C
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
	RJMP _0x202005A
_0x202005C:
	CPI  R18,58
	BRLO _0x202005D
	SBRS R16,3
	RJMP _0x202005E
	SUBI R18,-LOW(7)
	RJMP _0x202005F
_0x202005E:
	SUBI R18,-LOW(39)
_0x202005F:
_0x202005D:
	SBRC R16,4
	RJMP _0x2020061
	CPI  R18,49
	BRSH _0x2020063
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x2020062
_0x2020063:
	RJMP _0x20200CA
_0x2020062:
	CP   R21,R19
	BRLO _0x2020067
	SBRS R16,0
	RJMP _0x2020068
_0x2020067:
	RJMP _0x2020066
_0x2020068:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x2020069
	LDI  R18,LOW(48)
_0x20200CA:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x202006A
	ANDI R16,LOW(251)
	ST   -Y,R20
	CALL SUBOPT_0x1F
	CPI  R21,0
	BREQ _0x202006B
	SUBI R21,LOW(1)
_0x202006B:
_0x202006A:
_0x2020069:
_0x2020061:
	CALL SUBOPT_0x1D
	CPI  R21,0
	BREQ _0x202006C
	SUBI R21,LOW(1)
_0x202006C:
_0x2020066:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x2020059
	RJMP _0x2020058
_0x2020059:
_0x2020056:
	SBRS R16,0
	RJMP _0x202006D
_0x202006E:
	CPI  R21,0
	BREQ _0x2020070
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL SUBOPT_0x1F
	RJMP _0x202006E
_0x2020070:
_0x202006D:
_0x2020071:
_0x2020030:
_0x20200C9:
	LDI  R17,LOW(0)
_0x202001B:
	RJMP _0x2020016
_0x2020018:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	CALL __GETW1P
	CALL __LOADLOCR6
_0x20C0004:
	ADIW R28,20
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	CALL __SAVELOCR4
	CALL SUBOPT_0x22
	SBIW R30,0
	BRNE _0x2020072
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x20C0003
_0x2020072:
	MOVW R26,R28
	ADIW R26,6
	CALL __ADDW2R15
	MOVW R16,R26
	CALL SUBOPT_0x22
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R30,LOW(0)
	STD  Y+8,R30
	STD  Y+8+1,R30
	MOVW R26,R28
	ADIW R26,10
	CALL SUBOPT_0x23
	LDI  R30,LOW(_put_buff_G101)
	LDI  R31,HIGH(_put_buff_G101)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R26,R28
	ADIW R26,10
	RCALL __print_G101
	MOVW R18,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	MOVW R30,R18
_0x20C0003:
	CALL __LOADLOCR4
	ADIW R28,10
	POP  R15
	RET
_printf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	ST   -Y,R17
	ST   -Y,R16
	MOVW R26,R28
	ADIW R26,4
	CALL __ADDW2R15
	MOVW R16,R26
	LDI  R30,LOW(0)
	STD  Y+4,R30
	STD  Y+4+1,R30
	STD  Y+6,R30
	STD  Y+6+1,R30
	MOVW R26,R28
	ADIW R26,8
	CALL SUBOPT_0x23
	LDI  R30,LOW(_put_usart_G101)
	LDI  R31,HIGH(_put_usart_G101)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R26,R28
	ADIW R26,8
	RCALL __print_G101
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,8
	POP  R15
	RET

	.CSEG
_rtc_init:
	ST   -Y,R26
	LDD  R30,Y+2
	ANDI R30,LOW(0x3)
	STD  Y+2,R30
	LDD  R30,Y+1
	CPI  R30,0
	BREQ _0x2040003
	LDD  R30,Y+2
	ORI  R30,0x10
	STD  Y+2,R30
_0x2040003:
	LD   R30,Y
	CPI  R30,0
	BREQ _0x2040004
	LDD  R30,Y+2
	ORI  R30,0x80
	STD  Y+2,R30
_0x2040004:
	CALL SUBOPT_0x24
	LDI  R26,LOW(7)
	CALL _i2c_write
	LDD  R26,Y+2
	RJMP _0x20C0001
_rtc_get_time:
	ST   -Y,R27
	ST   -Y,R26
	CALL SUBOPT_0x24
	LDI  R26,LOW(0)
	CALL SUBOPT_0x25
	CALL SUBOPT_0x26
	CALL SUBOPT_0x27
	CALL SUBOPT_0x28
	MOV  R26,R30
	CALL _bcd2bin
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	ST   X,R30
	CALL _i2c_stop
	ADIW R28,6
	RET
_rtc_set_time:
	ST   -Y,R26
	CALL SUBOPT_0x24
	LDI  R26,LOW(0)
	CALL SUBOPT_0x29
	LDD  R26,Y+1
	CALL _bin2bcd
	MOV  R26,R30
	CALL SUBOPT_0x2A
_0x20C0001:
	CALL _i2c_write
	CALL _i2c_stop
_0x20C0002:
	ADIW R28,3
	RET
_rtc_get_date:
	ST   -Y,R27
	ST   -Y,R26
	CALL SUBOPT_0x24
	LDI  R26,LOW(3)
	CALL SUBOPT_0x25
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ST   X,R30
	CALL SUBOPT_0x27
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	ST   X,R30
	CALL SUBOPT_0x27
	CALL SUBOPT_0x28
	CALL SUBOPT_0x26
	CALL _i2c_stop
	ADIW R28,8
	RET
_rtc_set_date:
	ST   -Y,R26
	CALL SUBOPT_0x24
	LDI  R26,LOW(3)
	CALL _i2c_write
	LDD  R26,Y+3
	CALL SUBOPT_0x2A
	CALL _i2c_write
	LDD  R26,Y+1
	CALL _bin2bcd
	MOV  R26,R30
	CALL SUBOPT_0x29
	CALL _i2c_stop
	ADIW R28,4
	RET

	.CSEG

	.CSEG
_strlen:
	ST   -Y,R27
	ST   -Y,R26
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
	ST   -Y,R27
	ST   -Y,R26
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
	lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret

	.CSEG
_bcd2bin:
	ST   -Y,R26
    ld   r30,y
    swap r30
    andi r30,0xf
    mov  r26,r30
    lsl  r26
    lsl  r26
    add  r30,r26
    lsl  r30
    ld   r26,y+
    andi r26,0xf
    add  r30,r26
    ret
_bin2bcd:
	ST   -Y,R26
    ld   r26,y+
    clr  r30
bin2bcd0:
    subi r26,10
    brmi bin2bcd1
    subi r30,-16
    rjmp bin2bcd0
bin2bcd1:
    subi r26,-10
    add  r30,r26
    ret

	.DSEG
_Buff:
	.BYTE 0x16
_pass:
	.BYTE 0x5
_saved_pass:
	.BYTE 0x5

	.ESEG
_saved_rfid_1:
	.DB  0x30,0x30,0x30,0x32
	.DB  0x32,0x30,0x38,0x38
	.DB  0x35,0x34
	.DB  0x0
_saved_rfid_2:
	.DB  0x30,0x30,0x30,0x38
	.DB  0x39,0x38,0x39,0x35
	.DB  0x38,0x32
	.DB  0x0

	.DSEG
__base_y_G100:
	.BYTE 0x4
__lcd_y:
	.BYTE 0x1
__lcd_maxx:
	.BYTE 0x1

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:29 WORDS
SUBOPT_0x0:
	CALL _lcd_clear
	__POINTW2FN _0x0,0
	JMP  _lcd_putsf

;OPTIMIZER ADDED SUBROUTINE, CALLED 17 TIMES, CODE SIZE REDUCTION:45 WORDS
SUBOPT_0x1:
	LDI  R27,0
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x2:
	MOV  R30,R17
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x3:
	ADD  R26,R30
	ADC  R27,R31
	SUBI R30,LOW(-_Buff)
	SBCI R31,HIGH(-_Buff)
	LD   R30,Z
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4:
	CALL _lcd_clear
	__POINTW2FN _0x0,14
	JMP  _lcd_putsf

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x5:
	MOVW R26,R28
	JMP  _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x6:
	CALL _lcd_clear
	__POINTW2FN _0x0,18
	CALL _lcd_putsf
	__POINTW1FN _0x0,32
	ST   -Y,R31
	ST   -Y,R30
	__GETD1N 0xD
	CALL __PUTPARD1
	LDI  R24,4
	CALL _printf
	ADIW R28,6
	LDI  R26,LOW(200)
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x7:
	__POINTW1FN _0x0,37
	ST   -Y,R31
	ST   -Y,R30
	__GETD1N 0xD
	CALL __PUTPARD1
	LDI  R24,4
	CALL _printf
	ADIW R28,6
	LDI  R26,LOW(200)
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:24 WORDS
SUBOPT_0x8:
	__POINTW1FN _0x0,49
	ST   -Y,R31
	ST   -Y,R30
	__GETD1N 0x22
	CALL __PUTPARD1
	CALL __PUTPARD1
	__GETD1N 0xD
	CALL __PUTPARD1
	LDI  R24,12
	CALL _printf
	ADIW R28,14
	LDI  R26,LOW(200)
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x9:
	CALL _lcd_putsf
	LDI  R26,LOW(600)
	LDI  R27,HIGH(600)
	CALL _delay_ms
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0xA:
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R7
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0xB:
	MOV  R30,R6
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	MOV  R30,R9
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:77 WORDS
SUBOPT_0xC:
	MOV  R30,R11
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	MOV  R30,R10
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	MOV  R30,R13
	LDI  R31,0
	SUBI R30,LOW(-2000)
	SBCI R31,HIGH(-2000)
	CALL __CWD1
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xD:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LD   R0,X
	MOV  R26,R17
	LDI  R27,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0xE:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	MOVW R30,R28
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,134
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R16
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
	MOVW R26,R28
	ADIW R26,4
	JMP  _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0xF:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(1)
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x10:
	__POINTW2FN _0x0,110
	JMP  _lcd_putsf

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x11:
	CALL _get_keypad
	MOV  R17,R30
	CPI  R17,10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x12:
	CALL _lcd_putsf
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x13:
	LDI  R24,8
	CALL _sprintf
	ADIW R28,12
	RJMP SUBOPT_0x5

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x14:
	CALL _lcd_clear
	__POINTW2FN _0x0,221
	RJMP SUBOPT_0x12

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x15:
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0xC

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x16:
	LDI  R24,12
	CALL _sprintf
	ADIW R28,16
	RJMP SUBOPT_0x5

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x17:
	CALL _lcd_clear
	__POINTW2FN _0x0,276
	CALL _lcd_putsf
	CALL _get_pass
	LDS  R30,_saved_pass
	LDS  R26,_pass
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x18:
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOV  R26,R17
	LDI  R27,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x19:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1A:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,1
	STD  Y+1,R30
	STD  Y+1+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R17,R30
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x1B:
	LDI  R26,LOW(48)
	CALL __lcd_write_nibble_G100
	__DELAY_USW 200
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1C:
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x1D:
	ST   -Y,R18
	LDD  R26,Y+13
	LDD  R27,Y+13+1
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x1E:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1F:
	LDD  R26,Y+13
	LDD  R27,Y+13+1
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x20:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x21:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x22:
	MOVW R26,R28
	ADIW R26,12
	CALL __ADDW2R15
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x23:
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x24:
	CALL _i2c_start
	LDI  R26,LOW(208)
	JMP  _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x25:
	CALL _i2c_write
	CALL _i2c_stop
	CALL _i2c_start
	LDI  R26,LOW(209)
	CALL _i2c_write
	LDI  R26,LOW(1)
	JMP  _i2c_read

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x26:
	MOV  R26,R30
	CALL _bcd2bin
	LD   R26,Y
	LDD  R27,Y+1
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x27:
	LDI  R26,LOW(1)
	CALL _i2c_read
	MOV  R26,R30
	JMP  _bcd2bin

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x28:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ST   X,R30
	LDI  R26,LOW(0)
	JMP  _i2c_read

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x29:
	CALL _i2c_write
	LD   R26,Y
	RCALL _bin2bcd
	MOV  R26,R30
	JMP  _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2A:
	CALL _i2c_write
	LDD  R26,Y+2
	RCALL _bin2bcd
	MOV  R26,R30
	RET


	.CSEG
	.equ __sda_bit=6
	.equ __scl_bit=5
	.equ __i2c_port=0x12 ;PORTD
	.equ __i2c_dir=__i2c_port-1
	.equ __i2c_pin=__i2c_port-2

_i2c_init:
	cbi  __i2c_port,__scl_bit
	cbi  __i2c_port,__sda_bit
	sbi  __i2c_dir,__scl_bit
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay2
_i2c_start:
	cbi  __i2c_dir,__sda_bit
	cbi  __i2c_dir,__scl_bit
	clr  r30
	nop
	sbis __i2c_pin,__sda_bit
	ret
	sbis __i2c_pin,__scl_bit
	ret
	rcall __i2c_delay1
	sbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	ldi  r30,1
__i2c_delay1:
	ldi  r22,13
	rjmp __i2c_delay2l
_i2c_stop:
	sbi  __i2c_dir,__sda_bit
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
__i2c_delay2:
	ldi  r22,27
__i2c_delay2l:
	dec  r22
	brne __i2c_delay2l
	ret
_i2c_read:
	ldi  r23,8
__i2c_read0:
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_read3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_read3
	rcall __i2c_delay1
	clc
	sbic __i2c_pin,__sda_bit
	sec
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	rol  r30
	dec  r23
	brne __i2c_read0
	mov  r23,r26
	tst  r23
	brne __i2c_read1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_read2
__i2c_read1:
	sbi  __i2c_dir,__sda_bit
__i2c_read2:
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay1

_i2c_write:
	ldi  r23,8
__i2c_write0:
	lsl  r26
	brcc __i2c_write1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_write2
__i2c_write1:
	sbi  __i2c_dir,__sda_bit
__i2c_write2:
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_write3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_write3
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	dec  r23
	brne __i2c_write0
	cbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	ldi  r30,1
	sbic __i2c_pin,__sda_bit
	clr  r30
	sbi  __i2c_dir,__scl_bit
	rjmp __i2c_delay1

_delay_ms:
	adiw r26,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r26,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
