#include <mega16a.h>
#include <alcd.h>
#include <delay.h>
#include <stdio.h>
#include <i2c.h>
#include <ds1307.h>

#define show_rfid_keypad_num 13 // this is num in keypad that u use as setting button 
#define Time_setting_keypad_num 14 //in keypad 
#define new_rfid_keypad_num 15 //in keypad 
#define show_time_keypad_num 16 // in key pad


#define BUZZER PORTC.0 
#define RELAY PORTB.2
#define LED1 PORTB.3
#define LED2 PORTB.4

#ifndef RXB8
#define RXB8 1
#endif

#ifndef TXB8
#define TXB8 0
#endif

#ifndef UPE
#define UPE 2
#endif

#ifndef DOR
#define DOR 3
#endif

#ifndef FE
#define FE 4
#endif

#ifndef UDRE
#define UDRE 5
#endif

#ifndef RXC
#define RXC 7
#endif

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<DOR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)

#define GSM_POWER_ON PORTD.3

int Index;
unsigned char Buff[22] ;
unsigned char pass[5];// get pass from function 
 char saved_pass[5]={1,2,3,4}; // saved  pass //eeprom 
     
 eeprom char saved_rfid_1[11]="0002208854";
 eeprom char saved_rfid_2[11]="0008989582"; 
 
  unsigned char valid_check_rfid(char *id_buffer );
  unsigned char get_keypad(void);//get keypad button number                 
  unsigned char get_number(void);//get number in integer from get_keypad() 
  unsigned int get_pass(void);
  unsigned char show_saved_rfid(void);
  void time_setting(void);          
  unsigned char new_rfid_card(void); 
  void show_time_and_date(void);
  
 flash unsigned char keytbl[16]={0x77, 0x7B, 0x7D, 0xB7,
  0xBB, 0xBD, 0xD7, 0xDB,
   0xDD, 0xEB, 0xE7, 0xED,
    0x7e,0xBE, 0xDE, 0xEE};   
    
    unsigned char hour,min,sec,week_day,day,month,year;
    
 void main(void){
 char temp_buff[11],i=0;  
   
 unsigned char val=0,fail_count=0;
 
 
 DDRB=(1<<2)|(1<<3)|(1<<4); // led s and relay  
 DDRC=0X01; // BUZZER OUTPUT PIN  
 DDRD=(1<<3);
 // USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud Rate: 9600
UCSRA=0x00;
UCSRB=0x98;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x33;

 lcd_init(16);
 lcd_clear();
 lcd_putsf("RFID DOOR SEC"); 
 
 i2c_init();
 rtc_init(0,0,0);
 rtc_set_time(12,0,0); 
 rtc_set_date(2,1,2,11);  
 
 LED1=1;
 delay_ms(150);
 LED1=0;     
 
 GSM_POWER_ON=1;
 delay_ms(1000);
 GSM_POWER_ON=0;
 
 #asm("sei")
    while(1){  
      
     
    
    if(get_keypad()==show_rfid_keypad_num){ // goto to show saved rfid if...  
     
     show_saved_rfid(); }
     
    
     if(get_keypad()== Time_setting_keypad_num){ // goto to Time setting if...  
     
     time_setting(); }  
     
     if(get_keypad()== new_rfid_keypad_num){ // goto to new card  if...  
     
     new_rfid_card(); }  
     
     
   if(get_keypad()== show_time_keypad_num){ // goto to show time...  
     
     show_time_and_date(); }    
      
     
      if(Index==10){//RFID Ready in Buffer
         for(i=0;i<10;i++){
         temp_buff[i]=Buff[i];
         }
       lcd_clear();    
       lcd_putsf("ID=");
       lcd_puts(temp_buff); 
       
      val= valid_check_rfid(temp_buff);  
          if(val==1){
               RELAY=1;
               BUZZER=0;//valid rfid can stop buzzer alarm
               lcd_clear(); 
               lcd_putsf(" Sending SMS ");  
               printf("AT%c",13);
               delay_ms(200);
               printf("AT+CMGF=1%c",13);
               delay_ms(200);
               printf("AT+CMGS=%c09194176015%c%c",34,34,13); //  sms
               delay_ms(200);  
               putsf("ok ID=");   
              puts(temp_buff);    
              printf("%d:%d:%d %d/%d/%d/" ,hour,min,sec,day,month,2000+year);
               printf("%c%c",13,26);       
               
                  
     
               delay_ms(100);  
               lcd_clear(); 
               lcd_putsf("SMS SENT   ");
               delay_ms(200);   
               lcd_clear();
               lcd_putsf("RFID DOOR SEC"); 
          }else //failed 
          {       
           lcd_clear(); 
               lcd_putsf("Wrong card"); 
               delay_ms(600); 
               lcd_clear();
               lcd_putsf("RFID DOOR SEC"); 
               RELAY=0;  
               fail_count++;
               if(fail_count>3){// 
               BUZZER=1;
               fail_count=0;
               lcd_clear(); 
                   lcd_putsf(" Sending SMS ");  
                   printf("AT%c",13);
                   delay_ms(200);
                   printf("AT+CMGF=1%c",13);
                   delay_ms(200);
                   printf("AT+CMGS=%c09194176015%c%c",34,34,13); //  sms  // +98 9194176015
                   delay_ms(200);
                     putsf("Error ID=");   
              puts(temp_buff);    
              printf("%d:%d:%d %d/%d/%d/" ,hour,min,sec,day,month,2000+year);
               printf("%c%c",13,26);  
                   delay_ms(100);  
                   lcd_clear(); 
                   lcd_putsf("SMS SENT   "); 
                   delay_ms(200);  
                   lcd_clear();
                 lcd_putsf("RFID DOOR SEC"); 
               }
          }
      Index=0;//Clear Buffer Index
      }
      
      
      }
   }  
 
 // USART Receiver interrupt service routine
interrupt [USART_RXC] void usart_rx_isr(void)
{
char status,data;
status=UCSRA;
data=UDR;
#asm("cli")
if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
   {
   Buff[Index]=data;
   Index++;    
   }  
    LED2=~LED2;

 #asm("sei")
}
//-------------valid check rfid------------------------------
unsigned char valid_check_rfid(char* id_buffer)
{
    
bit flg = 0 ;
char i=0;
 lcd_clear();
 lcd_putsf("RFID DOOR SEC"); 
  delay_ms(30); 
  
   for(i=0;i<10;i++){ 
      if(id_buffer[i]!=saved_rfid_1[i]){ 
      flg=1 ;
      break ; 
    }
  }

   if (flg)
    {
     for(i=0;i<10;i++){  
        if(id_buffer[i]!=saved_rfid_2[i]){
        return 0 ; 
        }
      }
     }
return 1 ;
  
}
//end of cali check rfid fuction -------

///----get keypad -------------------

  unsigned char get_keypad(void){  
  unsigned char key=0, butnum;
  
  DDRA = 0x0f;
  PORTA = 0xf0;
  delay_us(5);
  key = PINA;
  DDRA = 0xf0;
  PORTA = 0x0f;
  delay_us(5);
  key = key | PINA;
  delay_us(5); 
 
    if (key != 0xff)
   {
     for (butnum=0; butnum<16; butnum++) {
     if (keytbl[butnum]==key) break;
    }
  
    butnum++;
    }
   else butnum=100;  
   return butnum;   
  } 
  //-----end of get keypad function------------ 
         
  //---get number ----
  /***this function use get_keypad() function and gets 2 digit integer  ***/
   unsigned char get_number(void){
   unsigned char z,x,y,buff[16];  // x is first num y is second and then our num=(x*10)+y 
   aval:
  do{
   x=get_keypad(); 
   if(x==10){x=0;}
   if(x>10){x=100;}
   }while(x==100);  
   
   do{
   z=get_keypad();
   }while(z !=100);
   
   delay_ms(40);
   lcd_gotoxy(0,1); 
   sprintf(buff,"%d",x);
   lcd_puts(buff);    
   delay_ms(40);
   
   do{
   y=get_keypad();
   if(y==10){y=0;}
   if(y>12){y=100;}
   }while(y==100); 
 
   do{
   z=get_keypad();
   }while(z !=100);     
     
   if(x<10){
    if(y<10){
    x*=10;
    x=x+y;
    } 
   }         
   lcd_gotoxy(0,1); 
   sprintf(buff,"%d",x);
   lcd_puts(buff); 
   
   while(1){  
   if(y==11){ return x;} //enter pressed
   if(y==12){ //corect pressed
   lcd_gotoxy(0,1);
   lcd_putsf("  ");
   goto aval;}  
   y=get_keypad();
   }  
  } 
  //---end of get number function
  //---get_pass function-----
  unsigned int get_pass(void){//this function will get 4 digits pass from admin
  unsigned char digit1;  
  unsigned char sens_for_edge; 
 // char temp_lcd_buffer[17];
  
   
   do{  //get digit 1
   digit1=get_keypad(); 
   if(digit1==10){digit1=0;}
   if(digit1>10){digit1=100;}
   }while(digit1==100); 
   
   do{  //wait until no button ...
   sens_for_edge=get_keypad();
   }while(sens_for_edge!=100);
   
   pass[0]=digit1;
   
   lcd_gotoxy(0,1);                          
   lcd_putsf("Pass=*"); 
    

   do{  //get digit 2
   digit1=get_keypad(); 
   if(digit1==10){digit1=0;}
   if(digit1>10){digit1=100;}
   }while(digit1==100);     
   
   do{  //wait until no button ...
   sens_for_edge=get_keypad();
   }while(sens_for_edge!=100);
     
   pass[1]=digit1;
   
   lcd_gotoxy(0,1);                          
   lcd_putsf("Pass=**");   
   
   do{  //get digit 3
   digit1=get_keypad(); 
   if(digit1==10){digit1=0;}
   if(digit1>10){digit1=100;}
   }while(digit1==100);     
   
   do{  //wait until no button ...
   sens_for_edge=get_keypad();
   }while(sens_for_edge!=100);
     
   pass[2]=digit1;
   
   lcd_gotoxy(0,1);                          
   lcd_putsf("Pass=***");    
   
    do{  //get digit 4
   digit1=get_keypad(); 
   if(digit1==10){digit1=0;}
   if(digit1>10){digit1=100;}
   }while(digit1==100);     
   
   do{  //wait until no button ...
   sens_for_edge=get_keypad();
   }while(sens_for_edge!=100);
     
   pass[3]=digit1;                       
   lcd_gotoxy(0,1);                         
  lcd_putsf("Pass=****");  
   
   return 0;
  
  } 
  //---end of get pass function-----
 
  
  //unsigned char hour,min,sec,week_day,day,month,year;
  //---time and date setting function -----    
  
  void time_setting(void){
  unsigned char buff[16];
  lcd_clear();
  lcd_putsf("Set system Time");
  lcd_gotoxy(5,1);
  sprintf(buff,"??:%d:%d",min,sec);
  lcd_puts(buff); 
   do{  
   lcd_gotoxy(0,1);
   lcd_putsf("  ");
   hour=get_number();
   }while(hour>23);
   lcd_clear();  
    
  lcd_putsf("set system Time");
  lcd_gotoxy(5,1);
  sprintf(buff,"%d:??:%d",hour,sec);
  lcd_puts(buff); 
   do{  
   lcd_gotoxy(0,1);
   lcd_putsf("  ");
   min=get_number();
   }while(min>59);   
   lcd_clear();    
   
   
  lcd_putsf("Set system date"); //day
  lcd_gotoxy(5,1);
  sprintf(buff,"??/%02d/%02d",day,month,2000+year);
  lcd_puts(buff); 
   do{  
   lcd_gotoxy(0,1);
   lcd_putsf("  ");
   day=get_number();
   }while(day>31);
   lcd_clear();    
   
   lcd_putsf("Set system date"); //month
  lcd_gotoxy(5,1);
  sprintf(buff,"%02d/??/%d",day,month,2000+year);
  lcd_puts(buff); 
   do{  
   lcd_gotoxy(0,1);
   lcd_putsf("  ");
   month=get_number();
   }while(month>12);
   lcd_clear();
   
   lcd_putsf("Set system date"); //year
  lcd_gotoxy(5,1);
  sprintf(buff,"%02d/%02d/20??",day,month,2000+year);
  lcd_puts(buff); 
   do{  
   lcd_gotoxy(0,1);
   lcd_putsf("  ");
   year=get_number();
   }while(year>99);
  
   
   rtc_set_time(hour,min,0);
   rtc_set_date(1,day,month,year);
    lcd_clear(); 
  show_time_and_date();
    
  }
  //---end of time and date setting
  
   //-----show saved rfid function -----
  unsigned char show_saved_rfid(void){  
  char temp_buff_3[11],temp_buff_4[11]; 
  unsigned char i;   
  lcd_clear();
  lcd_putsf("Enter Password:");
  get_pass(); 
   if(pass[0]==saved_pass[0] && pass[1]==saved_pass[1] 
   && pass[2]==saved_pass[2] && pass[3]==saved_pass[3]){
  
     for(i=0;i<10;i++){
      temp_buff_3[i] = saved_rfid_1[i];
     } 
     for(i=0;i<10;i++){
      temp_buff_4[i] = saved_rfid_2[i];
     }
    lcd_clear();
    lcd_puts(&temp_buff_3[0]);
    delay_ms(1);
    lcd_gotoxy(0,1);
    lcd_puts(&temp_buff_4[0]);
  
    while(get_keypad()!=show_rfid_keypad_num);// if show button pushed exit  
     while(get_keypad()==show_rfid_keypad_num);//debuonce   
      lcd_clear();
 lcd_putsf("RFID DOOR SEC");      
   }
     else{   
     lcd_clear();
      lcd_putsf("wrong Pass"); 
      delay_ms(500); 
      lcd_clear();
 lcd_putsf("RFID DOOR SEC"); 
     return 0;
     }  
  } 
  //-----end of show saved rfid function-----  
  
    //----- save new rfid card function -----
  unsigned char new_rfid_card(void){  
  unsigned char i,flash_number=1;          
  char temp_buff_2[11];
  lcd_clear();
  lcd_putsf("Enter Password:");
  get_pass(); 
   if(pass[0]==saved_pass[0] && pass[1]==saved_pass[1] 
   && pass[2]==saved_pass[2] && pass[3]==saved_pass[3]){  
   
   lcd_clear();
   lcd_putsf("Enter 1 or 2 ?"); //flash_number
   do{  
   lcd_gotoxy(0,1);
   lcd_putsf("  ");
   flash_number=get_number();
   }while(flash_number>2);
   
   
   lcd_clear();
   lcd_putsf("close card");  
   
   while(get_keypad()!=new_rfid_keypad_num){
   
     if(Index==10){//RFID Ready in Buffer  
     
       if(flash_number==2){
       for(i=0;i<10;i++){  //0-9 +null 
         temp_buff_2[i]=Buff[i];
         saved_rfid_1[i]=Buff[i];
         }
       
       }  
       
        if(flash_number==1){
        for(i=0;i<10;i++){  //11
         temp_buff_2[i]=Buff[i];
         saved_rfid_2[i]=Buff[i];
         }      
       }
         
       lcd_clear();    
       lcd_putsf("ID=");
       lcd_puts(temp_buff_2); 
      Index=0;//Clear Buffer Index  
     
      }
  
     } 
     while(get_keypad()==new_rfid_keypad_num);//for debounce   
     lcd_clear();
 lcd_putsf("RFID DOOR SEC"); 
   }
     else{    
     lcd_clear();
      lcd_putsf("wrong Pass");  
      delay_ms(600); 
      lcd_clear();
 lcd_putsf("RFID DOOR SEC"); 
     return 0;
     }  
  } 
  //-----end of save new rfid card function -----  
  
  ///------show time 
    void show_time_and_date(void){  
     char display_buffer[17],display_buffer2[17];
    rtc_get_time(&hour,&min,&sec);
    
  rtc_get_date(&week_day,&day,&month,&year);        
      
    sprintf(display_buffer,"Time: %2d:%02d:%02d",hour,min,sec);  
 sprintf(display_buffer2,"Date: %2d/%02d/%d",day,month,2000+year);

    lcd_clear();       
    lcd_puts(display_buffer);
    delay_ms(3); 
    lcd_gotoxy(0,1);
    lcd_puts(display_buffer2);
    delay_ms(1000); 
    lcd_clear();
    lcd_putsf("RFID DOOR SEC");
    }
  //--end of show time 
 